/* JollyJumper 29
Retour d'été 2018 
*/  

//..............................................................................................................
// Etat de charge des deux batteries secondaires Gel 110Ah

// Broches pour l'alimentation des capteurs de courant ACS712
#define CurrentSensorsVccPin 49
   
// Broches pour mesure de tension Batteries secondaires et mesures des courants
// 0: tension, 1: Isolaire, 2: ILeft +/-5A, 3: ILeft +/-20A, 4: IRight +/-5A, 5: IRight +/-20A   
const byte BattPin[6] {10,9,7,8,3,4}; // n° des entrées analogiques de mesures   
// Pentes et ordonnées à l'origine des droites de conversion des tensions lues U/I = p*Rdg + b  
const float p[6] {0.0153271,0.030965,0.030857,0.056350,0.030738,0.057335}; // version4 après essais sur place   
const float b[6] {0.0134664,-13.487345,-13.434204,-24.308726,-13.463774,-24.738755}; //  Vcc 4.98 V   , capteurs ACS712 à 4.20 V                         
const byte RdgNumber=10; // Nombre de lectures pour lisser les mesures de I et U

//********************************************************************************************************************
// crées pour cet exercice
float battI[6]; // pour stocker les mesures d'intensités fournies par les différents capteurs de I
int battI, I5, I20; // pour essayer de stoker les mesures d'intensité à 5A et 20A plus bas



//********************************************************************************************************************
// Mesures électriques U, I et % de charge batteries secondaires


// Mesure de l'intensité (via la tension de la voie n° _elecNumber)
float getI(byte _ElecNumber)  
{
   int RdgI=0;
  
   for (int i=0; i<RdgNumber; i++) {  // constante RdgNumber 
      RdgI+=analogRead(BattPin[_ElecNumber]);
   }
   return ((p[_ElecNumber]*RdgI)/(RdgNumber*1.0))+b[_ElecNumber];  
}
// Fin de getI()...............................................................

// Appel de la fonction
// I5=getI(2);


// Mesure de deux intensités en calibre 5 A et 20A (via les tensions des voies n° _elecNumber5 et _ElecNumber20 )
// Sortie par modification d'un tableau de variables globales (méthode plutôt déconseillée)

void getTab2I(byte _ElecNumber5, byte _ElecNumber20)  
// ici procédure sans déclaration de variables de sortie car un tableau n'est pas considéré comme une seule variable
{
     battI[_ElecNumber5]=getI(_ElecNumber5);
     battI[_ElecNumber20]=getI(_ElecNumber20);
}
// Fin de getTab2I()...............................................................

// Appel de la procédure :
// getTab2I(2, 3);


// Mesure de deux intensités en calibre 5 A et 20A (via les tensions des voies n° _elecNumber5 et _ElecNumber20 )
// Tentative interdite de Sortie par deux variables simultanée ! : impossible

void get2INotOK(byte _ElecNumber5, byte _ElecNumber20, int _I5, int _I20)  
// ici procédure sans déclaration de variables de sortie car un tableau n'est pas considéré comme une seule variable
{
     _I5=getI(_ElecNumber5);
     _I20=getI(_ElecNumber20);
}
// Fin de getTab2I().....................................................................................

// L'appel de cette procédure incorrecte créera une erreur à la compilation
// get2INotOK(2,3,I5,I20);  


// Mesure de deux intensités en calibre 5 A et 20A (via les tensions des voies n° _elecNumber5 et _ElecNumber20 )
// Sortie en indiquant les adresses des deux variables (ou plus) : techniquement possible

void getAddr2I(byte _ElecNumber5, byte _ElecNumber20, int *_I5, int *_I20)  
// ici procédure avec déclaration de variables de sortie avec passage par addresse des variables
{                                          // *adresse dans la déclaration de procédure
     *_I5=getI(_ElecNumber5);             // _I5 variable locale à la procédure (différente de I5!)
     *_I20=getI(_ElecNumber20);          // *_I5 adresse de la variable locale à la procédure
}
// Fin de getAddr2I().....................................................................................

// Appel de la procédure :
// getAddr2I(2,3, &I5, &I20);  //&I5 adresse de la variable globale I5 apelée par la procédure


// Fonction renvoyant la meilleure valeur d'intensité en choissisant le capteur le mieux adapté
// selon le résultat de la mesure : équivalent à un choix automatique de calibre sur l'ampèremètre

float getBattI(byte _ElecNumber5, byte _ElecNumber20)
{
  int RdgTestI,RdgMin, RdgMax;
  RdgMin=round((-5-b[_ElecNumber20])*1.0/[_ElecNumber20]);
  RdgMax=round((5-b[_ElecNumber20])*1.0/[_ElecNumber20]);
  
  RdgTestI=analogRead(BattPin[_ElecNumber20]);  // I<5 A?
  if((RdgTestI<RdgMin)||(RdgTestI>RdgMax)) { // Lire sur capteur 20A
     // Limites calculées selon la calibration 4 en cours (alim capteurs 4.2 V)
     // bornes initiale 400-600 envisagée pour alim capteur 5V
     return getI(_ElecNumber20);
  }
  else { // Lire sur capteur 5A
     return getI(_ElecNumber5);  
  }
} 
// Fin de getBattI().......................................................................................

// Appel de la fonction :
// battI=getBattI(2,3);


//***********************************************************************************************************
// SETUP du programme principal
//***********************************************************************************************************

void setup() {
   Serial.begin(19200); 
      
   setupElec(StandByCS); 
   
   
} // Fin du setup()


//**************************************************************************************************
// BOUCLE principale
//**************************************************************************************************

void loop(void)
{  
   //etc.  j'ai enlevé tout le coeur de mon programme d'acquisition
   
}  // Fin de loop()
