/* JollyJumper 29

Modification de calcul de la pression atmosphérique réduite au niveau de la mer L1262, log complet de P0
Faradic Efficienty = 1.0  [L1626], modif des codes ChoiceSwitch dont réglage 0x1 sans GPS, 901x sans GSM
   
inclu:  
- Déclaration de variables par section  [code vers 70]
- Affichage TFT et menu tactile TS (6 + eco)  [code vers L238]
- message d'erreur : warning  [code vers L283]
- Menu [code vers L294]
- Gestion carte SD du shield TFT par librairie Sd  [code vers L320] 
  Test systématique de bonne ouverture SD sinon WDT reboot
- Affichage Date & Heure RTC - prise en compte heure été dans setupRTC [code vers L477], getTime() [L499]
- Temperature & Régulation (PWM ext 13 à 1000Hz) [code vers L573]
- TempLogger à n, 3T avec bouclage sur 200 valeurs  [code vers L707]
  ou en continu : n, 3T, Date et Time 
- Grapher 3T sur fichier de bouclage (0-50°C)  [code vers L781]
- Grapher avec choix de base de temps (tempGrapher et tempRama (cor)) [code vers L879 et L995]
- Lecture et affichage état des eaux sales  [code vers L1160]
- Pression locale et réduite au niveau de la mer selon l'altitude [code vers L1213]
- PressureLogger en boucle sur 200 valeurs  [code vers L1306]
- PressureGrapher sur 48h (cor) [code vers L1385]
- Mesures de tension et courants des batteries secondaires (version 4), état de charge en % de 110A/h [code vers L1551]
- Nouvelle calibration des capteurs (mega alimenté en 5V par carte JJ, capteurs I en 4.2V) [code vers L170]
- Mémorisation des dernières valeurs d'état de charge des batterie (en cas de reset)  [code vers L1709]
- ElecLogger sur SD en boucle sur 200 valeurs et elecGrapher pour % charges et courant solaire [code vers 1771]
- ElecLoopGrapher (cor) [code vers 1861]
- GPS : affichage coordonnées, altitude, distance, date et heure  [code vers L1998]  Bibliothèque AltSoftSerial (bug sur Serial3?) 
- GPSLogger sur SD si déplacement significatif (200m)   [code vers L2065]
- Menu Réglages (mise à 100% etc.), sécurité par interrupteurs ChoiceSwitch [code vers L2202]
- GSM pour transfert de position GPS par SMS [code vers L2298]
- WatchDogTimer (test de pulse, PWM, SD, delai) journal d'exécution stocké sur SD, [code vers L2408]
  Code d'erreur : cause du WDT Mega et log de WDT Nano [code vers L2536]  setupLogger  [code vers L2487], 
  printSetpLog sur TFT  [code vers L2579],  WDTelecLogger [code vers L2648], correction des cumulX [code vers L2775]
- Gestion du cycle de mesure de ~15mn getMeasureLoop() (cor)  [code vers L2838]

setup [code vers L2911]        waitForGPSafterReboot() [code vers L2818]
loop [code vers L2971]   Menu Switch [code vers L3023]   Gestion des zones tactiles  [code vers L3104]

ATTENTION : Upload par USB Mega implique que raccord G µC Arduino Nano soit débranché 
*/

//********************************************
// Déclaration des bibliothèques utilisées
//********************************************
/*
#include <math.h> // fonction de calcul et de conversion
#include <stdlib.h>
#include "SPI.h"  // Utilisation du TFT shield
#include <Wire.h>
#include "Adafruit_GFX.h"
#include "Adafruit_ILI9341.h"
#include <Adafruit_STMPE610.h>
#include <SD.h> // Changement futur de librairie "SdFat.h" ? C++ (pour limiter et gérer les erreurs : reboot? )
#include "RTClib.h"  // Utilisation RTC real Time Clock
#include <SFE_BMP180.h> // Utilisation du capteur I2C de pression Bosch BMP180 
#include <TinyGPS++.h> // Utilisation du GPS u-Blox Neo-7M
#include <AltSoftSerial.h> // en l'état TinyGPS++ réclame une liaison série logicielle
*/

#include <OneWire.h>  // Utilisation des capteurs DS18B20
#include <DallasTemperature.h>



//****************************************************
// Déclaration préalables par domaines fonctionnels
//****************************************************

// Elagué

//........................................................................................................
// Températures & Régulation

#define OneWireBusPin 2 // Data OneWire sur Arduino Mega 
#define PWMfanPin 13  // Commande PWM 13 à 980Hz des ventilateurs du réfrigérateur Mega 2-13 /44-46
// changer pour libérer 13 pour le GSM???? Non
boolean FanOnFlag;

OneWire oneWire(OneWireBusPin); // Crée l'instance de communication OneWire
DallasTemperature sensors(&oneWire); // Passe la référence OneWire à la bibliothèque DallasTemperature

// Assigne les addresses des capteurs OneWire DS18B20 obtainues avec
// http://www.hacktronics.com/Tutorials/arduino-1-wire-address-finder.html
DeviceAddress fridgeThermometer = { 0x28, 0xFF, 0x3F, 0x17, 0x91, 0x16, 0x04, 0xB9 };//Yellow
DeviceAddress outsideThermometer = { 0x28, 0xFF, 0x13, 0x16, 0x91, 0x16, 0x04, 0xEF };//Blue
DeviceAddress insideThermometer = { 0x28, 0xFF, 0x2E, 0xA3, 0x94, 0x16, 0x05, 0xFC };//Red

float TempOutside, TempInside, TempFridge;//  

// Elagué




//**********************************************************************************************************
// Temperature & Régulation

void setupTempControl() //pour le setup
{
   pinMode(PWMfanPin, OUTPUT); // PWM 980 Hz sur broche 13 (ou relais mais sans PWM!) pour le ventilateur
   digitalWrite(PWMfanPin,LOW); // arrêt ventilateur à l'initialisation
   
   sensors.begin();//librarie Dallas Temperature
   sensors.setResolution(insideThermometer, 11);  // choix de résolution 
   sensors.setResolution(outsideThermometer, 11); // entre 9 et 12 bit 
   sensors.setResolution(fridgeThermometer, 11);  // 10 suffirait?

   Serial.println("setupTempControl done");
}
// Fin de setupTempControl()..............................................................................


void getTemperatures()// Acquisition sur les trois sondes de températures DS18B20
{
   sensors.requestTemperatures();   

   TempOutside=sensors.getTempC(outsideThermometer);   
   TempInside=sensors.getTempC(insideThermometer);   
   TempFridge=sensors.getTempC(fridgeThermometer); 
}
// Fin de getTemperature().................................................................................


void printOneTemperature(DeviceAddress deviceAddress, String _deviceAdress)  // Utilitaire utile?
{
   float TempC = sensors.getTempC(deviceAddress);
   if (TempC == -127.00) {
       warning("Error getting temperature on");
       tft.fillRect(0, 270, 240, 15, ILI9341_BLACK );
       tft.setCursor(5, 278); tft.setTextColor(ILI9341_RED); tft.setTextSize(1); tft.print(_deviceAdress);
       delay( 6000);// modifier pour TFT s'efface après loop
   } 
   else {
            
      if(_deviceAdress=="outsideThermometer") {
          tft.setCursor(5, 225); tft.setTextColor(ILI9341_CYAN); tft.setTextSize(1); 
          tft.print("Text="); tft.print(TempC,1);
      }
      if(_deviceAdress=="insideThermometer") {
          tft.setCursor(85, 225); tft.setTextColor(ILI9341_YELLOW); tft.setTextSize(1); 
          tft.print("Tint="); tft.print(TempC,1);
      }
      if(_deviceAdress=="fridgeThermometer") {
          tft.setCursor(165, 225); tft.setTextColor(ILI9341_RED); tft.setTextSize(1); 
          tft.print("Tfrigo="); tft.print(TempC,1);
      }
   } // if      
} 
// Fin de printOneTemperature()..........................................................................


void printTemperature()  // Affichage sur TFT
{
   tft.setRotation(2);// Nettoyage de la zone de tracé
   tft.fillRect(0, 220, 240, 20, ILI9341_BLACK );

   printOneTemperature(outsideThermometer,"outsideThermometer");
   printOneTemperature(insideThermometer,"insideThermometer");
   printOneTemperature(fridgeThermometer,"fridgeThermometer");

   Serial.println("Getting temperatures...");
   Serial.print("TempOutside ");Serial.print(TempOutside);Serial.println(" oC");
   Serial.print("TempInside ");Serial.print(TempInside);Serial.println(" oC");
   Serial.print("TempFridge ");Serial.print(TempFridge);Serial.println(" oC");
}
// Fin de printTemperature()


// Gestion de la ventilation arrière du réfrigérateur
// initialisation dans Setup avec fanInit : true. Appel dans Loop avec fanInit : false
void fanControl(float TempFridgeC, float TempInsideC, boolean fanInit )
{
   static boolean FanOn;//donc valeur mémorisée jusqu'à l'appel suivant
   // pour initialisation FanOn dans le setup bien que variable locale de type static...
   if(fanInit==true) {FanOn=false;}

   // Régulation en "Tout ou Rien" avec hystérésis à deux seuils
   // Test du seuil haut conditionnel
   if((TempFridgeC>25)&&(TempFridgeC>(TempInsideC+5)))  {
        if(FanOn==false) {// démarrer en douceur le ventilateur Artic F8 à 12V
            FanOn=true;
            analogWrite(PWMfanPin,51); //15% pwm 800 RPM
            delay(1000);  
            analogWrite(PWMfanPin,90); //35% pwm 1400 RPM
            delay(1000);
            analogWrite(PWMfanPin,153);//60% pwm 1700 RPM
            delay(1000);
            analogWrite(PWMfanPin,230);//90% pwm 1900 RPM
            delay(1000);
            digitalWrite(PWMfanPin,HIGH);// A Fond
            }   //sinon il tourne déjà...
   }
   // Test du seuil bas
   if((TempFridgeC<(TempInsideC+2))&&(FanOn==true)) {// arrêter en douceur le ventilateur
            FanOn=false;
            analogWrite(PWMfanPin,153);//60% pwm 1700 RPM
            delay(1000);  
            analogWrite(PWMfanPin,90); //35% pwm 1400 RPM
            delay(1000);
            analogWrite(PWMfanPin,51); //15% pwm 800 RPM
            delay(1000);
            digitalWrite(PWMfanPin,LOW);//Arrêt
   }

   FanOnFlag=FanOn; // Pour printFanControl()
}
// Fin de fanControl().................................................................................................................


// Affichage de l'état de fonctionnement du ventilateur : V si FanOn = true
void printFanControl()
{
    tft.fillRect(200, 240, 40, 15, ILI9341_BLACK ); // Nettoyage
    tft.drawRect(201, 240, 38, 15, ILI9341_CYAN );
    tft.setCursor(206, 244); tft.setTextColor(ILI9341_RED); tft.setTextSize(1); 
    if(FanOnFlag==true)
         {tft.print("V on");}
    else
         {tft.print("V off");}          
}
// Fin de printFanControl().................................................................................................................


/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

//  Elagué





//***********************************************************************************************************
// SETUP du programme principal
//***********************************************************************************************************

void setup() {
   Serial.begin(19200); 
   
   // Elagué...
                                                 
   setupTempControl(); // Initialisation mesure de température et régulation des ventilateurs
   getTemperatures();
   //TempFridge=28; TempInside=25; TempOutside=20; // valeurs statiques pour essai
   fanControl(TempFridge, TempInside, true);// FanOn=false au démarrage  .....................................................................

  
   // élagué...

   Serial.println("setup done"); Serial.println(""); 
} // Fin du setup()


//**************************************************************************************************
// BOUCLE principale
//**************************************************************************************************

void loop(void)
{  
      
   fanControl(TempFridge, TempInside, false);
   

//   j'ai élagué tout le reste du programme d'acquisition...

}
// Fin de loop()
